/* ===============================================================================================
 *	Vector 2d
 *	14.10.2006
 *	(C) faceH0r
 */

#ifndef _C_VECTOR_2D_H_
#define _C_VECTOR_2D_H_

class clVec2
{

public:

	float		x, y;

				clVec2	( void );
				clVec2	( float fx, float fy );

	void		operator += ( clVec2 vVector );
	void		operator -= ( clVec2 vVector );
	void		operator *= ( clVec2 vVector );
	void		operator /= ( clVec2 vVector );

	void		operator += ( float fValue );
	void		operator -= ( float fValue );
	void		operator *= ( float fValue );
	void		operator /= ( float fValue );

	clVec2	operator +	( clVec2 vVector );
	clVec2	operator -	( clVec2 vVector );
	clVec2	operator *	( clVec2 vVector );
	clVec2	operator /	( clVec2 vVector );

	clVec2	operator +	( float fValue );
	clVec2	operator -	( float fValue );
	clVec2	operator *	( float fValue );
	clVec2	operator /	( float fValue );

	float		operator &	( clVec2 vVector );

	float		operator []	( int iIndex );

	void		VecSet		( float fx, float fy );
	void		VecZero		( void );
	clVec2		VecNormal	( void );
	void		VecNormalize	( void );

	float		CosBetween	( clVec2 vVector );

	clVec2	PerpVector	( void );
	clVec2	GetNormal	( void );

	float		GetLength	( void );
	float		GetQLength	( void );

	void		VecReflect	( clVec2 vVector );
	void		VecRotate	( float fAngle );

private:

};

#endif